import java.io.PrintWriter;
import java.lang.reflect.*;

public class Trace implements InvocationHandler{
	private Object target;
	private PrintWriter output;

	public static Object createProxy(Object obj,PrintWriter out){
		return Proxy.newProxyInstance(obj.getClass().getClassLoader(),
										obj.getClass().getInterfaces(),
										new Trace(obj,out));
	}

	private Trace(Object obj, PrintWriter out){ 	
		target=obj;
		output=out;
	}
	
	public Object invoke(Object proxy, Method method, Object[] args) throws Exception{
		Object result = null;
		output.println(method.getName() + "(...) is called");
		result = method.invoke(target,args);
		output.println(method.getName()+" returns: "+result);
		return result;
	}
}