import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.LinkedList;

public class Inventory{
	private List<Car> inventory;

	public static void main(String[] args){
		Inventory i = new Inventory();
		System.out.println("\nPrinting Inventory");
		i.printInventory();
		System.out.println("\nAdd an Accord to Inventory");
		
		Object[] initArgs = new Object[6];
		initArgs[0]=new String("Accord");
		initArgs[1]=new String("LX");
		initArgs[2]=new String("2342A34KFSZZ49");
		initArgs[3]=new String("Gold");
		initArgs[4]=new String("New York");
		initArgs[5]=new Double(25948.25);
		
		i.addCar((String) initArgs[0],initArgs);
		System.out.println("\nPrinting Inventory");
		i.printInventory();
		
		//we add the default car to inventory
		//to show we can call constructor without
		//parameters
		
		System.out.println("\nAdd a default Accord to Inventory");
		i.addCar((String) initArgs[0],new Object[0]);
		System.out.println("\nPrinting Inventory");
		i.printInventory();
	}
	public Inventory(){
		inventory = new LinkedList<Car>();
	}
	public void addCar(String carName, Object[] initArgs){
		try{
			Class carClass = Class.forName(carName);
			Class[] initClassArgs= new Class[initArgs.length];
			for(int i=0;i<initArgs.length;i++){
				initClassArgs[i]=initArgs[i].getClass();
			}
			Constructor carConstructor =
				carClass.getConstructor(initClassArgs);
			
			Car newCar = (Car)carConstructor.newInstance(initArgs);
			inventory.add(newCar);
		}
		catch (Exception e){
			System.out.println(e);
		}
	
	}
	public void printInventory(){
		System.out.println("Cars in Inventory: "+inventory.size());
		for(Car c: inventory)
			c.getInfo();
		
	}
}